xref: /xnu-10002.81.5/tools/remote_build.sh (revision 5e3eaea39dcf651e66cb99ba7d70e32cc4a99587) !
1*5e3eaea3SApple OSS Distributions#!/bin/bash
2*5e3eaea3SApple OSS Distributions#
3*5e3eaea3SApple OSS Distributions# Script that rsyncs a source/build tree to a remote server, performs a build,
4*5e3eaea3SApple OSS Distributions# and copies the result back
5*5e3eaea3SApple OSS Distributions#
6*5e3eaea3SApple OSS Distributions
7*5e3eaea3SApple OSS Distributions# This script is invoked instead of the initial recursive make(1) in ./Makefile.
8*5e3eaea3SApple OSS Distributions# First it must cache all binaries that might be used during the build by
9*5e3eaea3SApple OSS Distributions# calling "make print_exports" (any target would work) with an overriden xcrun(1)
10*5e3eaea3SApple OSS Distributions# which caches tools an SDKs into ./BUILD/obj/BuildTools. When the combined
11*5e3eaea3SApple OSS Distributions# source+build tree is rsync-ed to the remote server, we run a script to
12*5e3eaea3SApple OSS Distributions# re-initiate the build using an overriden xcrun(1) which hands back
13*5e3eaea3SApple OSS Distributions# cached tools in ./BUILD/obj/BuildTools instead of whatever Xcode tools are on
14*5e3eaea3SApple OSS Distributions# the remote system (or if no Xcode tools are installed remotely). Finally,
15*5e3eaea3SApple OSS Distributions# the build results are copied back locally.
16*5e3eaea3SApple OSS Distributions#
17*5e3eaea3SApple OSS Distributions
18*5e3eaea3SApple OSS Distributionsfunction die() {
19*5e3eaea3SApple OSS Distributions    echo "$1" 1>&2
20*5e3eaea3SApple OSS Distributions    exit 1
21*5e3eaea3SApple OSS Distributions}
22*5e3eaea3SApple OSS Distributions
23*5e3eaea3SApple OSS Distributions
24*5e3eaea3SApple OSS DistributionsTARGET=
25*5e3eaea3SApple OSS Distributionsdeclare -a ARGS
26*5e3eaea3SApple OSS Distributionsdeclare -a REMOTEARGS
27*5e3eaea3SApple OSS Distributionsindex=0
28*5e3eaea3SApple OSS Distributionsfor arg in "$@"; do
29*5e3eaea3SApple OSS Distributions    case $arg in
30*5e3eaea3SApple OSS Distributions	_REMOTEBUILD_TARGET=*)
31*5e3eaea3SApple OSS Distributions	    TARGET=`echo $arg | awk -F= '{print $2}'`
32*5e3eaea3SApple OSS Distributions	    continue
33*5e3eaea3SApple OSS Distributions	    ;;
34*5e3eaea3SApple OSS Distributions	_REMOTEBUILD_MAKE=*)
35*5e3eaea3SApple OSS Distributions	    MAKE=`echo $arg | awk -F= '{print $2}'`
36*5e3eaea3SApple OSS Distributions	    continue
37*5e3eaea3SApple OSS Distributions	    ;;
38*5e3eaea3SApple OSS Distributions	REMOTEBUILD=*)
39*5e3eaea3SApple OSS Distributions	    # Don't restart another remote build remotely
40*5e3eaea3SApple OSS Distributions	    ;;
41*5e3eaea3SApple OSS Distributions	SRCROOT=*)
42*5e3eaea3SApple OSS Distributions	    continue
43*5e3eaea3SApple OSS Distributions	    ;;
44*5e3eaea3SApple OSS Distributions	OBJROOT=*)
45*5e3eaea3SApple OSS Distributions	    continue
46*5e3eaea3SApple OSS Distributions	    ;;
47*5e3eaea3SApple OSS Distributions	SYMROOT=*)
48*5e3eaea3SApple OSS Distributions	    continue
49*5e3eaea3SApple OSS Distributions	    ;;
50*5e3eaea3SApple OSS Distributions	DSTROOT=*)
51*5e3eaea3SApple OSS Distributions	    continue
52*5e3eaea3SApple OSS Distributions	    ;;
53*5e3eaea3SApple OSS Distributions	CCHROOT=*)
54*5e3eaea3SApple OSS Distributions	    continue
55*5e3eaea3SApple OSS Distributions	    ;;
56*5e3eaea3SApple OSS Distributions	RC_XBS=*)
57*5e3eaea3SApple OSS Distributions	    # Remote build isn't chrooted or special in any way
58*5e3eaea3SApple OSS Distributions	    arg="VERBOSE=YES"
59*5e3eaea3SApple OSS Distributions	    continue
60*5e3eaea3SApple OSS Distributions	    ;;
61*5e3eaea3SApple OSS Distributions	VERBOSE=YES)
62*5e3eaea3SApple OSS Distributions	    set -x
63*5e3eaea3SApple OSS Distributions	    ;;
64*5e3eaea3SApple OSS Distributions    esac
65*5e3eaea3SApple OSS Distributions    ARGS[$index]="$arg"
66*5e3eaea3SApple OSS Distributions    REMOTEARGS[$index]="\"$arg\""
67*5e3eaea3SApple OSS Distributions    index=$(($index+1))
68*5e3eaea3SApple OSS Distributionsdone
69*5e3eaea3SApple OSS Distributions
70*5e3eaea3SApple OSS Distributions
71*5e3eaea3SApple OSS DistributionsRSYNC_ARGS="-azvh"
72*5e3eaea3SApple OSS DistributionsARGS[$index]="REMOTEBUILD="
73*5e3eaea3SApple OSS DistributionsREMOTEARGS[$index]="\"REMOTEBUILD=\""
74*5e3eaea3SApple OSS Distributions
75*5e3eaea3SApple OSS Distributions# For some targets like installsrc, we can't to a remote build
76*5e3eaea3SApple OSS DistributionsSKIPREMOTE=0
77*5e3eaea3SApple OSS Distributionscase $TARGET in
78*5e3eaea3SApple OSS Distributions    clean)
79*5e3eaea3SApple OSS Distributions	SKIPREMOTE=1
80*5e3eaea3SApple OSS Distributions	;;
81*5e3eaea3SApple OSS Distributions    installsrc)
82*5e3eaea3SApple OSS Distributions	SKIPREMOTE=1
83*5e3eaea3SApple OSS Distributions	;;
84*5e3eaea3SApple OSS Distributions    installopensource)
85*5e3eaea3SApple OSS Distributions	SKIPREMOTE=1
86*5e3eaea3SApple OSS Distributions	;;
87*5e3eaea3SApple OSS Distributions    cscope)
88*5e3eaea3SApple OSS Distributions	SKIPREMOTE=1
89*5e3eaea3SApple OSS Distributions	;;
90*5e3eaea3SApple OSS Distributions    tags)
91*5e3eaea3SApple OSS Distributions	SKIPREMOTE=1
92*5e3eaea3SApple OSS Distributions	;;
93*5e3eaea3SApple OSS Distributions    help)
94*5e3eaea3SApple OSS Distributions	SKIPREMOTE=1
95*5e3eaea3SApple OSS Distributions	;;
96*5e3eaea3SApple OSS Distributionsesac
97*5e3eaea3SApple OSS Distributions
98*5e3eaea3SApple OSS Distributionsif [ $SKIPREMOTE -eq 1 ]; then
99*5e3eaea3SApple OSS Distributions    exec "$MAKE" "$TARGET" "${ARGS[@]}"
100*5e3eaea3SApple OSS Distributionsfi
101*5e3eaea3SApple OSS Distributions
102*5e3eaea3SApple OSS DistributionsSRC="$(pwd -P)"
103*5e3eaea3SApple OSS DistributionsSRCNAME="$(basename $SRC)"
104*5e3eaea3SApple OSS Distributions
105*5e3eaea3SApple OSS Distributions# Pick up build locations passed in the environment
106*5e3eaea3SApple OSS DistributionsOBJROOT="${OBJROOT}"
107*5e3eaea3SApple OSS DistributionsSYMROOT="${SYMROOT}"
108*5e3eaea3SApple OSS DistributionsDSTROOT="${DSTROOT}"
109*5e3eaea3SApple OSS Distributions
110*5e3eaea3SApple OSS Distributionsif [ -z "${OBJROOT}" ]; then
111*5e3eaea3SApple OSS Distributions    die "OBJROOT not set in environment"
112*5e3eaea3SApple OSS Distributionsfi
113*5e3eaea3SApple OSS Distributionsmkdir -p "${OBJROOT}" || die "Could not create ${OBJROOT}"
114*5e3eaea3SApple OSS Distributions
115*5e3eaea3SApple OSS Distributionsif [ -z "${SYMROOT}" ]; then
116*5e3eaea3SApple OSS Distributions    die "SYMROOT not set in environment"
117*5e3eaea3SApple OSS Distributionsfi
118*5e3eaea3SApple OSS Distributionsmkdir -p "${SYMROOT}" || die "Could not create ${SYMROOT}"
119*5e3eaea3SApple OSS Distributions
120*5e3eaea3SApple OSS Distributionsif [ -z "${DSTROOT}" ]; then
121*5e3eaea3SApple OSS Distributions    die "DSTROOT not set in environment"
122*5e3eaea3SApple OSS Distributionsfi
123*5e3eaea3SApple OSS Distributionsmkdir -p "${DSTROOT}" || die "Could not create ${DSTROOT}"
124*5e3eaea3SApple OSS Distributions
125*5e3eaea3SApple OSS Distributionsif [ "$REMOTEBUILD" = "$SPECIALREMOTEBUILD" ]; then
126*5e3eaea3SApple OSS Distributions    :
127*5e3eaea3SApple OSS Distributionselse
128*5e3eaea3SApple OSS Distributions    DOINSTALLSRC=0
129*5e3eaea3SApple OSS Distributions    REMOTE_SRCREL="./"
130*5e3eaea3SApple OSS Distributions    BUILDTOOLSDIR="$OBJROOT"
131*5e3eaea3SApple OSS Distributions    REMOTE_BUILDTOOLSREL="./BUILD/obj"
132*5e3eaea3SApple OSS Distributions    BUILDSCRIPTDIR="$OBJROOT"
133*5e3eaea3SApple OSS Distributions    REMOTE_BUILDSCRIPTREL="./BUILD/obj"
134*5e3eaea3SApple OSS Distributions    BUILDSCRIPTNAME="build.sh"
135*5e3eaea3SApple OSS Distributions    if [ ! -d "${OBJROOT}/SETUP" ]; then
136*5e3eaea3SApple OSS Distributions    RSYNC_DELETE_EXCLUDED="--delete-excluded"
137*5e3eaea3SApple OSS Distributions    else
138*5e3eaea3SApple OSS Distributions    RSYNC_DELETE_EXCLUDED=""
139*5e3eaea3SApple OSS Distributions    fi
140*5e3eaea3SApple OSS Distributions    if [ ! -e "${SYMROOT}/" ]; then
141*5e3eaea3SApple OSS Distributions	RSYNC_DELETE_SYMROOT=1
142*5e3eaea3SApple OSS Distributions    else
143*5e3eaea3SApple OSS Distributions	RSYNC_DELETE_SYMROOT=0
144*5e3eaea3SApple OSS Distributions    fi
145*5e3eaea3SApple OSS Distributions    if [ ! -e "${DSTROOT}/" ]; then
146*5e3eaea3SApple OSS Distributions	RSYNC_DELETE_DSTROOT=1
147*5e3eaea3SApple OSS Distributions    else
148*5e3eaea3SApple OSS Distributions	RSYNC_DELETE_DSTROOT=0
149*5e3eaea3SApple OSS Distributions    fi
150*5e3eaea3SApple OSS Distributions    TARBUILDDIRS=0
151*5e3eaea3SApple OSS Distributionsfi
152*5e3eaea3SApple OSS Distributions
153*5e3eaea3SApple OSS Distributionsecho "Caching build tools..." 1>&2
154*5e3eaea3SApple OSS Distributionsmkdir -p "${BUILDTOOLSDIR}" || die "Could not create BUILDTOOLSDIR"
155*5e3eaea3SApple OSS Distributions$MAKE print_exports "${ARGS[@]}" XCRUN="${SRC}/tools/xcrun_cache.sh -c \"${BUILDTOOLSDIR}\"" >/dev/null || die "Could not cache build tools"
156*5e3eaea3SApple OSS Distributions
157*5e3eaea3SApple OSS Distributions# Cache the make(1) binary itself
158*5e3eaea3SApple OSS DistributionsMAKE_SDKROOT=`"${SRC}/tools/xcrun_cache.sh" -u "${BUILDTOOLSDIR}" -sdk / -show-sdk-path`
159*5e3eaea3SApple OSS Distributions"${SRC}/tools/xcrun_cache.sh" -c "${BUILDTOOLSDIR}" -sdk "${MAKE_SDKROOT}" -find make >/dev/null || die "Could not cache make"
160*5e3eaea3SApple OSS Distributions
161*5e3eaea3SApple OSS Distributions# Create a canned build script that can restart the build on the remote server.
162*5e3eaea3SApple OSS Distributionsmkdir -p "${BUILDSCRIPTDIR}" || die "Could not create BUILDSCRIPTDIR"
163*5e3eaea3SApple OSS Distributionscat > "${BUILDSCRIPTDIR}/${BUILDSCRIPTNAME}" <<EOF
164*5e3eaea3SApple OSS Distributions#!/bin/sh
165*5e3eaea3SApple OSS Distributionsmkdir -p /private/tmp
166*5e3eaea3SApple OSS Distributionsmkdir -p /private/var/tmp
167*5e3eaea3SApple OSS Distributionsmkdir -p "\${TMPDIR}"
168*5e3eaea3SApple OSS Distributionscd "${REMOTE_SRCREL}"
169*5e3eaea3SApple OSS Distributionsmkdir -p ./BUILD/obj
170*5e3eaea3SApple OSS Distributionsmkdir -p ./BUILD/sym
171*5e3eaea3SApple OSS Distributionsmkdir -p ./BUILD/dst
172*5e3eaea3SApple OSS DistributionsMAKE=\`\$PWD/tools/xcrun_cache.sh -u "\$PWD/${REMOTE_BUILDTOOLSREL}" -sdk / -find make\`
173*5e3eaea3SApple OSS Distributionsif [ -z "\${MAKE}" ]; then exit 1; fi
174*5e3eaea3SApple OSS Distributions\${MAKE} ${TARGET} ${REMOTEARGS[@]} XCRUN="\$PWD/tools/xcrun_cache.sh -u \"\$PWD/${REMOTE_BUILDTOOLSREL}\""
175*5e3eaea3SApple OSS Distributionsret=\$?
176*5e3eaea3SApple OSS Distributionsif [ \$ret -eq 0 ]; then
177*5e3eaea3SApple OSS Distributionsif [ ${TARBUILDDIRS} -eq 1 ]; then
178*5e3eaea3SApple OSS Distributionstar jcf ./BUILD/obj.tar.bz2 --exclude=\*.o --exclude=\*.cpo --exclude=\*.d --exclude=\*.cpd --exclude=\*.non_lto --exclude=\*.ctf --exclude=conf -C ./BUILD/obj . || exit 1
179*5e3eaea3SApple OSS Distributionstar jcf ./BUILD/sym.tar.bz2 -C ./BUILD/sym . || exit 1
180*5e3eaea3SApple OSS Distributionstar jcf ./BUILD/dst.tar.bz2 -C ./BUILD/dst . || exit 1
181*5e3eaea3SApple OSS Distributionsfi
182*5e3eaea3SApple OSS Distributionsfi
183*5e3eaea3SApple OSS Distributionsexit \$ret
184*5e3eaea3SApple OSS DistributionsEOF
185*5e3eaea3SApple OSS Distributionschmod a+x "${BUILDSCRIPTDIR}/${BUILDSCRIPTNAME}"
186*5e3eaea3SApple OSS Distributions#echo "Build script is:"
187*5e3eaea3SApple OSS Distributions#cat "${BUILDSCRIPTDIR}/${BUILDSCRIPTNAME}"
188*5e3eaea3SApple OSS Distributions
189*5e3eaea3SApple OSS Distributionsmkdir -p "${BUILDTOOLSDIR}/empty"
190*5e3eaea3SApple OSS Distributions
191*5e3eaea3SApple OSS Distributionsif [ "$REMOTEBUILD" = "$SPECIALREMOTEBUILD" ]; then
192*5e3eaea3SApple OSS Distributions    :
193*5e3eaea3SApple OSS Distributionselse
194*5e3eaea3SApple OSS Distributions
195*5e3eaea3SApple OSS Distributions    REMOTEBUILD="$REMOTEBUILD"
196*5e3eaea3SApple OSS Distributions    REMOTEBUILDPATH="$REMOTEBUILDPATH"
197*5e3eaea3SApple OSS Distributions
198*5e3eaea3SApple OSS Distributions    if [ -z "$REMOTEBUILDPATH" ]; then
199*5e3eaea3SApple OSS Distributions	WHOAMI=`whoami`
200*5e3eaea3SApple OSS Distributions	case "${REMOTEBUILD}" in
201*5e3eaea3SApple OSS Distributions	    *@*)
202*5e3eaea3SApple OSS Distributions		WHOAMI=`echo "${REMOTEBUILD}" | awk -F@ '{print $1}'`
203*5e3eaea3SApple OSS Distributions		;;
204*5e3eaea3SApple OSS Distributions	esac
205*5e3eaea3SApple OSS Distributions	REMOTEBUILDPATH="/tmp/$WHOAMI"
206*5e3eaea3SApple OSS Distributions    fi
207*5e3eaea3SApple OSS Distributions
208*5e3eaea3SApple OSS Distributions# Construct a unique remote path
209*5e3eaea3SApple OSS Distributions    eval `stat -s "${SRC}"`
210*5e3eaea3SApple OSS Distributions
211*5e3eaea3SApple OSS Distributions    REMOTEBUILDPATH="${REMOTEBUILDPATH}/$st_ino/${SRCNAME}/"
212*5e3eaea3SApple OSS Distributions    echo "Remote path is ${REMOTEBUILD}:${REMOTEBUILDPATH}" 1>&2
213*5e3eaea3SApple OSS Distributions
214*5e3eaea3SApple OSS Distributions    ssh $REMOTEBUILD "mkdir -p \"${REMOTEBUILDPATH}/BUILD/\"{obj,sym,dst}" || die "Could not make remote build directory"
215*5e3eaea3SApple OSS Distributions
216*5e3eaea3SApple OSS Distributions    # Copy source only
217*5e3eaea3SApple OSS Distributions    rsync $RSYNC_ARGS --delete --exclude=\*~ --exclude=.svn --exclude=.git --exclude=/BUILD . $REMOTEBUILD:"${REMOTEBUILDPATH}" || die "Could not rsync source tree"
218*5e3eaea3SApple OSS Distributions
219*5e3eaea3SApple OSS Distributions    # Copy partial OBJROOT (just build tools and build script), and optionally delete everything else
220*5e3eaea3SApple OSS Distributions    rsync $RSYNC_ARGS --delete $RSYNC_DELETE_EXCLUDED --include=/build.sh --include=/BuildTools --include=/BuildTools/\*\* --exclude=\* "${OBJROOT}/" $REMOTEBUILD:"${REMOTEBUILDPATH}/BUILD/obj/" || die "Could not rsync build tree"
221*5e3eaea3SApple OSS Distributions
222*5e3eaea3SApple OSS Distributions    # Delete remote SYMROOT if it has been deleted locally
223*5e3eaea3SApple OSS Distributions    if [ "$RSYNC_DELETE_SYMROOT" -eq 1 ]; then
224*5e3eaea3SApple OSS Distributions	rsync $RSYNC_ARGS --delete "${BUILDTOOLSDIR}/empty/" $REMOTEBUILD:"${REMOTEBUILDPATH}/BUILD/sym/" || die "Could not rsync delete SYMROOT"
225*5e3eaea3SApple OSS Distributions    fi
226*5e3eaea3SApple OSS Distributions
227*5e3eaea3SApple OSS Distributions    # Delete remote DSTROOT if it has been deleted locally
228*5e3eaea3SApple OSS Distributions    if [ "$RSYNC_DELETE_DSTROOT" -eq 1 ]; then
229*5e3eaea3SApple OSS Distributions	rsync $RSYNC_ARGS --delete "${BUILDTOOLSDIR}/empty/" $REMOTEBUILD:"${REMOTEBUILDPATH}/BUILD/dst/" || die "Could not rsync delete DSTROOT"
230*5e3eaea3SApple OSS Distributions    fi
231*5e3eaea3SApple OSS Distributions
232*5e3eaea3SApple OSS Distributions    # Start the build
233*5e3eaea3SApple OSS Distributions    echo ssh $REMOTEBUILD "/bin/bash -c 'cd \"${REMOTEBUILDPATH}\" && ${REMOTE_BUILDSCRIPTREL}/${BUILDSCRIPTNAME}'" 1>&2
234*5e3eaea3SApple OSS Distributions    ssh $REMOTEBUILD "/bin/bash -c 'cd \"${REMOTEBUILDPATH}\" && ${REMOTE_BUILDSCRIPTREL}/${BUILDSCRIPTNAME}'" || die "Could not complete remote build"
235*5e3eaea3SApple OSS Distributions
236*5e3eaea3SApple OSS Distributions    # Copy back build results except for object files (which might be several GB)
237*5e3eaea3SApple OSS Distributions    echo "Copying results back..."
238*5e3eaea3SApple OSS Distributions    rsync $RSYNC_ARGS --no-o --no-g --exclude=\*.o --exclude=\*.cpo --exclude=\*.d --exclude=\*.cpd --exclude=\*.non_lto --exclude=\*.ctf $REMOTEBUILD:"${REMOTEBUILDPATH}/BUILD/obj/" "${OBJROOT}/" || die "Could not rsync build results"
239*5e3eaea3SApple OSS Distributions    rsync $RSYNC_ARGS --no-o --no-g $REMOTEBUILD:"${REMOTEBUILDPATH}/BUILD/sym/" "${SYMROOT}/" || die "Could not rsync build results"
240*5e3eaea3SApple OSS Distributions    rsync $RSYNC_ARGS --no-o --no-g $REMOTEBUILD:"${REMOTEBUILDPATH}/BUILD/dst/" "${DSTROOT}/" || die "Could not rsync build results"
241*5e3eaea3SApple OSS Distributions
242*5e3eaea3SApple OSS Distributionsfi
243*5e3eaea3SApple OSS Distributions
244*5e3eaea3SApple OSS Distributionsexit 0
245